<?php
/***************************************************************************
 *   Professional Download System                                          *
 *                                                                         *
 *   Copyright (C) pirdani                                                 *
 *   pirdani@hotmail.de                                                    *
 *   http://pirdani.de/                                                    *
 *                                                                         *
 *   Copyright (C) 2005 EdEdster (Stefan Noss)                             *
 *   http://edsterathome.de/                                               *
 *                                                                         *
 *   Copyright (C) 2006-2008 Artur Wiebe                                   *
 *   wibix@gmx.de                                                          *
 *   http://wibix.de/                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
require_once('../../maincore.php');
require_once(BASEDIR.'subheader.php');
require_once(BASEDIR.'side_left.php');
require_once('include/common.php');
if(!iPDP_MOD) {
	fallback('download.php');
}
if(!$download->id) {
	fallback('download.php');
}
require_once('include/edit.php');


/*
 * GET
 */
// get latest timestamp
$query_id = dbquery("SELECT log_timestamp
	FROM ".DB_PREFIX."pdp_log
	WHERE download_id='".$download->id."'
	ORDER BY log_timestamp DESC LIMIT 1");
if(dbrows($query_id)) {
	$last_updated = array_shift(dbarray($query_id));
} else {
	$last_updated = 0;
}


/****************************************************************************
 * ACTION
 */
if(isset($_POST['set_status'])) {
	if($last_updated > $_POST['last_updated']) {
		fallback(FUSION_SELF."?did=".$download->id."&errno=".PDP_EUPDATED);
	}

	$status = stripinput($_POST['value']);
	if(!isset($locale['PDP904'])) {
		fallback(FUSION_SELF."?did=".$download->id);
	}

	$ok = $download->set_status($status);

	if($status==PDP_PRO_ON) {
		$download->inform_subscribers();
	}

	if($ok) {
		$download->log_event(PDP_EV_STATUS, 0);
		fallback(FUSION_SELF."?did=".$download->id);
	}

} elseif(isset($_POST['resetlog'])) {
	if($last_updated > $_POST['last_updated']) {
		fallback(FUSION_SELF."?did=".$download->id."&errno=".PDP_EUPDATED);
	}

	$ok = dbquery("DELETE FROM ".DB_PREFIX."pdp_log"
		." WHERE download_id='".$download->id."'");
	if($ok) {
		$download->log_event(PDP_EV_CLEARLOG, 0);
		fallback(FUSION_SELF."?did=".$download->id);
	}

} elseif(isset($_POST['resetbroken'])) {
	$ok = dbquery("UPDATE ".DB_PREFIX."pdp_downloads
		SET
		dl_broken_count='0'
		WHERE download_id='".$download->id."'");
	if($ok) {
		$download->log_event(PDP_EV_RESETBROKEN, 0);
		fallback(FUSION_SELF."?did=".$download->id);
	}

} elseif(isset($_POST['resetvisitors'])) {
	$ok = dbquery("UPDATE ".DB_PREFIX."pdp_downloads
		SET
		count_visitors='0'
		WHERE download_id='".$download->id."'");
	if($ok) {
		$download->log_event(PDP_EV_RESETVISITORS, 0);
		fallback(FUSION_SELF.'?did='.$download->id);
	}

} elseif(isset($_POST['setcount'])) {
	if(!isNum($_POST['count'])) {
		fallback(FUSION_SELF."?did=".$download->id);
	}

	$ok = dbquery("UPDATE ".DB_PREFIX."pdp_downloads"
		." SET dl_count='".$_POST['count']."'"
		." WHERE download_id='".$download->id."'");

	if($ok) {
		$download->log_event(PDP_EV_CHEAT, 0);
		fallback(FUSION_SELF."?did=".$download->id);
	}

} elseif(isset($_POST['deldownload'])) {
	fallback("admin/del_download.php?did=".$download->id);

} elseif(isset($_POST['set_max_pics'])) {
	$ok = dbquery("UPDATE ".DB_PREFIX."pdp_downloads"
		." SET"
		." max_pics='".intval($_POST['max_pics'])."'"
		." WHERE download_id='".$download->id."'");
	if($ok) {
		fallback(FUSION_SELF."?did=".$download->id);
	}
}


/*
 * GUI & ACTION
 */
if(isset($_GET['errno'])) {
	pdp_process_errno($_GET['errno']);
}

opentable($locale['PDP450']);

$sel_status = "";
foreach($locale['PDP904'] as $val => $title) {
	$sel_status .= "<option value='$val'"
		.($val==$download->status ? " selected" : "").">"
		."$title</option>\n";
}
echo "<form action='".FUSION_SELF."?did=".$download->id."' method='post'>
<input type='hidden' name='last_updated' value='$last_updated'>

<table width='100%' border='0' align='center' class='fusion-settings'>
<colgroup>
	<col width='33%' />
	<col width='*' />
</colgroup>
<tbody>
<tr>
	<th>".$locale['PDP454'].":</th>
	<td>".dbcount("(*)", "pdp_log", "(download_id='".$download->id."')")."</td>
	<td><input type='submit' class='button' name='resetlog'"
			." value='".$locale['PDP009']."'></td>
</tr>
<tr>
	<th>".$locale['PDP452'].":</th>
	<td><select class='textbox' name='value'>".$sel_status."</select></td>
	<td><input type='submit' class='button' name='set_status'"
			." value='".$locale['PDP453']."'></td>
</tr>
<tr>
	<th>".$locale['pdp_reset_visitors'].":</th>
	<td>".$download->data['count_visitors']."</td>
	<td><input type='submit' class='button' name='resetvisitors'"
			." value='".$locale['PDP456']."'></td>
</tr>
<tr>
	<th>".$locale['PDP455'].":</th>
	<td>".$download->data['dl_broken_count']."</td>
	<td><input type='submit' class='button' name='resetbroken'"
			." value='".$locale['PDP456']."'></td>
</tr>
<tr>
	<th>".$locale['PDP458'].":</th>
	<td><input type='text' class='textbox' name='max_pics' size='3'"
		." value='".$download->data['max_pics']."'></td>
	<td><input type='submit' class='button' name='set_max_pics'"
		." value='".$locale['PDP453']."'></td>
</tr>
<tr>
	<th>".$locale['PDP457'].":</th>
	<td><input type='text' class='textbox' name='count' size='7'"
		." value='".$download->data['dl_count']."'></td>
	<td><input type='submit' class='button' name='setcount'"
		." value='".$locale['PDP453']."'></td>
</tr>
<tr>
	<th>".$locale['PDP061'].":</th>
	<td>".dbcount("(*)", "pdp_notify", "(download_id='".$download->id."')")."</td>
	<td></td>
</tr>
<tr>
	<td></td>
	<td></td>
	<td><input type='submit' class='button' name='deldownload'"
		." value='".$locale['PDP880']."'></td>
</tr>
</tbody>
</table>
</form>
<hr>\n";




$query_id = dbquery("SELECT log.*, fu.user_name"
	." FROM ".DB_PREFIX."pdp_log AS log"
	." LEFT JOIN ".DB_PREFIX."users AS fu USING(user_id)"
	." WHERE download_id='".$download->id."'"
	." ORDER BY log_timestamp DESC");
if(!dbrows($query_id)) {
	echo "<p>".$locale['PDP451'];
} else {
	echo "<ul>\n";
}
while($data = dbarray($query_id)) {
	echo "<li>".showdate("shortdate", $data['log_timestamp'])
		." <a href='profile.php?id=".$data['user_id']."'>"
			.$data['user_name']."</a>"
		." - <b>".$locale['PDP903'][$data['log_type']]
		."</b> - ".$locale['PDP900'][$data['log_errno']]
		."</li>\n";
}
if(dbrows($query_id)) {
	echo "</ul>\n";
}


closetable();

require_once(BASEDIR."side_right.php");
require_once(BASEDIR."footer.php");
?>
