<?php
/***************************************************************************
 *   Professional Download System                                          *
 *                                                                         *
 *   Copyright (C) pirdani                                                 *
 *   pirdani@hotmail.de                                                    *
 *   http://pirdani.de/                                                    *
 *                                                                         *
 *   Copyright (C) 2005 EdEdster (Stefan Noss)                             *
 *   http://edsterathome.de/                                               *
 *                                                                         *
 *   Copyright (C) 2006-2007 Artur Wiebe                                   *
 *   wibix@gmx.de                                                          *
 *   http://wibix.de/                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
require_once("../../maincore.php");
require_once(BASEDIR."subheader.php");
require_once BASEDIR."side_left.php";
require_once("include/common.php");
if(!$download->can_edit) {
	$download->fallback_download();
}
require_once("include/edit.php");


if(isset($_GET['file_id']) && isNum($_GET['file_id'])) {
	$file_id = $_GET['file_id'];
} else {
	unset($file_id);
}


/****************************************************************************
 * FUNCS
 */
function pdp_get_files($path, $prefix, &$files)
{
	$handle = opendir($path);
	while(false !== ($file=readdir($handle))) {
		if(in_array($file, array('.', '..', '/', 'index.php',
			'.htaccess', '.htusers', '.htgroups'))) {
			continue;
		}
		if(is_dir($path.$file)) {
			pdp_get_files($path.$file, $file.'/', $files);
		} else {
			$files[] = $prefix.$file;
		}
	}
	closedir($handle);
	sort($files, SORT_STRING);
}



/****************************************************************************
 * ACTION
 */
$need_redir = false;

$log = false;
$log_event = PDP_EV_INVALID;
$log_errno = 0;

if(isset($_POST['save'])) {	// FIXME
	$size = stripinput($_POST['size']);
	$url = "";

	// try FTP first
	if(isset($_POST['save_ftp']) && !empty($_POST['save_ftp'])) {
		$log_event = PDP_EV_FILEFTP;
		if(!iPDP_MOD) {
			$download->log_event($log_event, PDP_EACCESS);
			fallback(FUSION_SELF."?did=".$download->id
				."&errno=".PDP_EACCESS);
		}
		$url = stripinput($_POST['save_ftp']);
		if(empty($size)) {
			$size = parsebytesize(filesize($pdp->settings['upload_file'].$url));
		}

	// try URL second
	} elseif(isset($_POST['url']) && !empty($_POST['url'])) {
		$log_event = PDP_EV_FILEURL;
		$url = stripinput($_POST['url']);
		if(!iPDP_MOD && !pdp_is_external($url)) {
			$download->log_event($log_event, PDP_EURL);
			fallback(FUSION_SELF."?did=".$download->id
				."&errno=".PDP_EURL);
		}

	// try UPLOAD last
	} elseif(isset($_FILES['upload'])
		&& $_FILES['upload']['error']!=UPLOAD_ERR_NO_FILE) {

		if(empty($pdp->settings['file_ext'])) {
			fallback(FUSION_SELF."?did=".$download->id);
		}

		$log_event = PDP_EV_FILEUPLOAD;

		// cannot be updated.
		if(isset($file_id)) {
			$download->log_event($log_event, PDP_EACCESS);
			fallback(FUSION_SELF."?did=".$download->id
				."&errno=".PDP_EACCESS);
		}

		$ext = explode(",", $pdp->settings['file_ext']);
		foreach($ext as $key => $val) {
			$ext[$key] = ".".$val;
		}

		$errno = pdp_upload_file($_FILES['upload'],
			$pdp->settings['upload_file'],
			$pdp->settings['file_max'], $ext, $url);
		if($errno) {
			$download->log_event($log_event, $errno);
			fallback(FUSION_SELF."?did=".$download->id
				."&errno=$errno");
		}
		if(empty($size)) {
			$size = parsebytesize(filesize($pdp->settings['upload_file'].$url));
		}
	} else {
		fallback(FUSION_SELF."?did=".$download->id);
	}

	$ver = stripinput($_POST['version']);
	$desc = stripinput($_POST['desc']);
	$now = time();
	if(empty($url)) {
		$url = "file_url";
	} else {
		$url = "'$url'";
	}
/*
	echo "<p><b>+ $url</b>\n";
	echo "<p><b>+ $size</b>\n";
*/

	// new
	if(!isset($file_id)) {
		$ok = dbquery("INSERT INTO ".DB_PREFIX."pdp_files"
			." SET download_id='".$download->id."'");
		$file_id = mysql_insert_id();
	} else {
		$file_id = stripinput($_GET['file_id']);
	}

	$ok = dbquery("UPDATE ".DB_PREFIX."pdp_files"
		." SET file_version='$ver',"
		." file_size='$size',"
		." file_desc='$desc',"
		." file_url=$url,"	// XXX - no '', cause can be a column
		." file_timestamp='$now'"
		." WHERE file_id='$file_id' AND download_id='".$download->id."'");

	$log = true;
	$log_errno = 0;
	$need_redir = true;

} elseif(isset($_GET['askdel']) && isset($file_id)) {
	$query_id = dbquery("SELECT file_url"
		." FROM ".DB_PREFIX."pdp_files"
		." WHERE file_id='".$file_id."' AND download_id='".$download->id."'");
	if(!dbrows($query_id)) {
		$download->log_event(PDP_EV_DELFILE, PDP_EFILE);
		fallback(FUSION_SELF."?did=".$download->id
			."&errno=".PDP_EFILE);
	}
	$url = array_shift(dbarray($query_id));


	// confirm
	if(pdp_is_external($url)) {
		fallback(FUSION_SELF."?did=".$download->id."&file_id=".$file_id
			."&del=1");
	}

	if(!is_writeable($pdp->settings['upload_file'])) {
		$url .= "<br><span class='small2'>"
			.str_replace("%s", "<b>".$pdp->settings['upload_file']."</b>",
				$locale['PDP885'])
			."</span>\n";
	}
	pdp_ask_del(FUSION_SELF."?did=".$download->id, $url, "file_id", $file_id);
} elseif(isset($_GET['del']) && isset($file_id)) {
	$log_event = PDP_EV_DELFILE;

	$query_id = dbquery("SELECT file_url"
		." FROM ".DB_PREFIX."pdp_files"
		." WHERE file_id='".$file_id."' AND download_id='".$download->id."'");
	if(!dbrows($query_id)) {
		$download->log_event($log_event, PDP_EFILE);
		fallback(FUSION_SELF."?did=".$download->id
			."&errno=".PDP_EFILE);
	}
	$url = array_shift(dbarray($query_id));

	if(isset($_GET['with_file'])) {
		@unlink($pdp->settings['upload_file'].$url);
	}
	$ok = dbquery("DELETE FROM ".DB_PREFIX."pdp_files"
		." WHERE file_id='".$file_id."'"
			." AND download_id='".$download->id."'");

	$log_errno = 0;
	$log = true;

	if($ok) {
		$need_redir = true;
	}
}


if($log) {
	$download->log_event($log_event, $log_errno);
}


if($need_redir && $download->status!=PDP_PRO_NEW) {
	if($download->set_status(PDP_PRO_OFF)) {
		fallback(FUSION_SELF."?did=".$download->id);
	}
}


/*
 * GUI - errno
 */
if(isset($_GET['errno'])) {
	pdp_process_errno($_GET['errno']);
}


/*
 * GUI
 */
$action = FUSION_SELF."?did=".$download->id;

if($download->status==PDP_PRO_NEW) {
	pdp_upload_step(2, "edit_pics.php", $download->id);
}


/*
 * GUI
 */
opentable($locale['PDP019']);


// files table
$query_id = dbquery("SELECT file_id, file_url, file_version, file_timestamp,"
	." file_desc, file_size"
	." FROM ".DB_PREFIX."pdp_files AS ff"
	." WHERE download_id='".$download->id."'"
	." ORDER BY file_timestamp DESC");
if(!dbrows($query_id)) {
	echo "<p>".$locale['PDP120'];
} else {
	echo "<table width='100%' cellspacing='1' class='tbl-border'>
<thead>
<tr>
	<th class='tbl2' width='16'></th>
	<th class='tbl2' width='16'></th>
	<th class='tbl2'>".$locale['PDP018']
		." [<a href='".FUSION_SELF."?did=".$download->id."'>"
			.$locale['PDP003']."</a>]</th>
	<th class='tbl2'>".$locale['PDP025']."</th>
	<th class='tbl2'>".$locale['PDP013']."</th>
	<th class='tbl2'>".$locale['PDP129']."</th>
	<th class='tbl2'>".$locale['PDP029']."</th>
	<th class='tbl2' width='16'></th>
</tr>
</thead>
<tbody>\n";
}

$count = 0;
$tbl = "class='tbl1'";
while($file = dbarray($query_id)) {
	$fid = $file['file_id'];

	if(pdp_is_external($file['file_url'])) {
		$dl_icon = "external.gif";
		$dl_link = $file['file_url'];
	} else {
		$dl_link = $pdp->settings['upload_file'].$file['file_url'];
		if(file_exists($dl_link)) {
			$dl_icon = "download.gif";
			$dl_link = "";//FIXME
		} else {
			$dl_icon = "nofile.gif";
			$dl_link = "";
		}
	}

	echo "<tr>
	<td $tbl><a href='$dl_link' target='_blank'><img src='icons/$dl_icon'"
		." alt='' border='0'></a></td>
	<td $tbl><a href='".FUSION_SELF."?did=".$download->id."&amp;file_id=$fid'>"
		."<img src='icons/edit.gif' border='0'"
			." alt='".$locale['PDP007']."'></a></td>
	<td $tbl>".$file['file_version']."</td>
	<td $tbl>".$file['file_desc']."</td>
	<td $tbl>".showdate("shortdate", $file['file_timestamp'])."</td>
	<td $tbl>".pdp_cleanup_filename($file['file_url'])."</td>
	<td $tbl>".$file['file_size']."</td>
	<td $tbl><a href='".FUSION_SELF."?did=".$download->id
		."&amp;file_id=".$fid
		."&amp;askdel=1'>"
		."<img src='icons/delete.gif' alt='' border='0'></a></td>
</tr>\n";
//	echo "<tr><td class='tbl1'></td><td class='tbl1' colspan='5'>".$file['file_url']."</td></tr>\n";
	$tbl = "class='tbl".(++$count%2+1)."'";
}
if(dbrows($query_id)) {
	echo "</tbody>
</table>
<table border='0'>
<tr>
	<td><img src='icons/nofile.gif' alt=''></td>
	<td>".$locale['PDP046']."</td>
</tr>
<tr>
	<td><img src='icons/download.gif' alt=''></td>
	<td>".$locale['PDP218']."</td>
</tr>
<tr>
	<td><img src='icons/external.gif' alt=''></td>
	<td>".$locale['PDP127']."</td>
</tr>
</table>\n";
}
closetable();
tablebreak();


/*
 * EDIT FORM
 */
opentable(isset($file_id) ? $locale['PDP128'] : $locale['PDP003']);

// form itself
$ver = "";
$desc = "";
$size = "";
$url = "";
$action = FUSION_SELF."?did=".$download->id;
$do_edit = false;

if(isset($file_id)) {
	$query_id = dbquery("SELECT file_id, file_url, file_version, file_desc,"
		." file_size"
		." FROM ".DB_PREFIX."pdp_files"
		." WHERE file_id='$file_id' AND download_id='".$download->id."'");
	if(!dbrows($query_id)) {
		fallback($action);
	}
	$data = dbarray($query_id);
	$url = $data['file_url'];
	$ver = $data['file_version'];
	$desc = $data['file_desc'];
	$size = $data['file_size'];

	$action = FUSION_SELF."?did=".$download->id."&file_id=$file_id";
	$do_edit = true;
}

// ftp files
if(iPDP_MOD) {
	$files = array();
	pdp_get_files($pdp->settings['upload_file'], '', $files);

	$sel_ftp = '<option value="">'.$locale['PDP033'].'</option>';
	$last_group = '';
	foreach($files as $file) {
		if($last_group != strtoupper(substr($file, 0, 1))) {
			if(!empty($last_group)) {
				$sel_ftp .= "</optgroup>\n";
			}
			$last_group = strtoupper(substr($file, 0, 1));
			$sel_ftp .= "<optgroup label='$last_group'>\n";
		}
		$sel_ftp .= "<option";
		if($url==$file) {
			$sel_ftp .= " selected";
			$url = "";
		}
		$sel_ftp .= " value='$file'>$file</option>\n";
	}
	$sel_ftp .= "</optgroup>\n";


	// OTHERS
	$src_url = "<tr>
	<td width='1%'>".$locale['PDP217'].":</td>
	<td><input type='text' class='textbox' name='url'"
		." value='$url' maxlegth='200' style='width:100%;'></td>
</tr>
<tr>
	<td></td>
	<td><span class='small2'>".$locale['PDP216']."</span></td>
</tr>\n";

	$src_ftp = "<tr>
	<td>".$locale['PDP218'].":</td>
	<td><select size='1' name='save_ftp' class='textbox'>".$sel_ftp
		."</select></td>
</tr>
<tr>
	<td></td><td><b>".$locale['PDP133']."</b></td>
</tr>\n";
} else {
	$src_ftp = "";

	$src_url = "<tr>
	<td width='1%'>".$locale['PDP217'].":</td>
	<td><input type='text' class='textbox' name='url'"
		." value='$url' maxlegth='200' style='width:100%;'></td>
</tr>
<tr>
	<td></td>
	<td><span class='small2'>".$locale['PDP220']."</span></td>
</tr>\n";
}
if($do_edit || empty($pdp->settings['file_ext'])) {
	$src_upload = "";
} else {
	$src_upload = "<tr>
	<td></td>
	<td><b>".$locale['PDP133']."</b></td>
</tr>
<tr>
	<td valign='top'>".$locale['PDP219'].":</td>\n";
	if(!is_writeable($pdp->settings['upload_file'])) {
		$src_upload .= "<td><span class='small2'>".str_replace("%s",
			"<b>".$pdp->settings['upload_file']."</b>",
			$locale['PDP900'][PDP_EUPDIR])."</span></td>";
	} else {
		$src_upload .= "<td><input type='file' class='textbox' name='upload' size='50'></td>
</tr>
<tr>
	<td></td>
	<td><span class='small2'>".$locale['PDP034'].": "
		.parsebytesize($pdp->settings['file_max'])
		." (".str_replace(",", ", ", $pdp->settings['file_ext'])
		.")</span></td>\n";
	}
	$src_upload .= "</tr>\n";
}


// determine what to show and why
$src_read_only = "";
if($do_edit) {
	$is_external = pdp_is_external($url);
	if(iPDP_MOD) {
	} else {
		$src_ftp = "";
		if(!$is_external) {
			$src_url = "";
			$src_read_only = "<tr><td><b>"
				.pdp_cleanup_filename($url)."</b></td></tr>\n";
		}
	}
} else {
	if(iPDP_MOD) {
	} else {
	}
}


echo "<form action='$action' method='post' name='editform'"
	." enctype='multipart/form-data'>
<table class='tbl-border' width='100%' cellspacing='1'>
<tr>
	<td class='tbl2' valign='top' width='150'>".$locale['PDP129'].": *</td>
	<td class='tbl1'>
<!--DOWNLOAD-SOURCE-BEGIN-->
<table border='0' width='100%'>
$src_read_only
$src_ftp
$src_url
$src_upload
</table>
<!--DOWNLOAD-SOURCE-END-->
	</td>
</tr>
<tr>
	<td class='tbl2'>".$locale['PDP018'].":</td>
	<td class='tbl1'><input type='text' class='textbox' name='version'"
		." value='$ver' maxlegth='20' size='20'></td>
</tr>
<tr>
	<td class='tbl2' valign='top'>".$locale['PDP029'].":</td>
	<td class='tbl1'><input type='text' class='textbox' name='size'"
		." value='$size' maxlegth='20' size='20'><br>"
		."<span class='small2'>".$locale['PDP221']."</span></td>
</tr>
<tr>
	<td class='tbl2'>".$locale['PDP025'].":</td>
	<td class='tbl1'><input type='text' class='textbox' name='desc'"
		." value='$desc' maxlegth='100' size='60'></td>
</tr>
<tr>
	<td colspan='2' align='center' class='tbl2'><input type='submit'"
		." class='button' name='save' value='".$locale['PDP010']."'></td>
</tr>
</table>
</form>\n";

closetable();


require_once BASEDIR."side_right.php";
require_once(BASEDIR."footer.php");
?>
