<?php
/***************************************************************************
 *   Professional Download System                                          *
 *                                                                         *
 *   Copyright (C) pirdani                                                 *
 *   pirdani@hotmail.de                                                    *
 *   http://pirdani.de/                                                    *
 *                                                                         *
 *   Copyright (C) 2005 EdEdster (Stefan Noss)                             *
 *   http://edsterathome.de/                                               *
 *                                                                         *
 *   Copyright (C) 2006-2007 Artur Wiebe                                   *
 *   wibix@gmx.de                                                          *
 *   http://wibix.de/                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
require_once("../../maincore.php");
require_once(BASEDIR."subheader.php");
require_once(BASEDIR."side_left.php");

require_once("include/common.php");
require_once("include/theme_funcs.php");

if(!iMEMBER) {
	fallback("download.php");
}

if(isset($_GET['id']) && isNum($_GET['id'])) {
	$id = $_GET['id'];
} else {
	fallback("download.php");
}


opentable($pdp->settings['title']);
pdp_menu();


$query_id = dbquery("SELECT user_name"
	." FROM ".DB_PREFIX."users"
	." WHERE user_id='$id'");
if(!dbrows($query_id)) {
	fallback("download.php");
}
echo "<p><b>".array_shift(dbarray($query_id)).":</b>"
	." <a href='".BASEDIR."profile.php?lookup=$id'>"
		.$locale['PDP161']."</a></p>\n";
echo "<hr>";
if(iPDP_MOD) {
	$where = "";
} elseif(iMEMBER) {
	$where = " AND ((dl_status='".PDP_PRO_ON."'"
		.($pdp->settings['hide_user_allow']=="yes"
			? " AND hide_user='no')"
			: ")")
		." OR user_id='".$userdata['user_id']."')";
} else {
	$where = " AND dl_status='".PDP_PRO_ON."'";
	if($pdp->settings['hide_user_allow']=="yes") {
		$where .= "AND hide_user='no'";
	}
}

$query_id = dbquery("SELECT dl_name, download_id, dl_status, dl_broken_count,"
	." cat_name, cat_access, dl.cat_id, hide_user"
	." FROM ".DB_PREFIX."pdp_downloads AS dl"
	." LEFT JOIN ".DB_PREFIX."pdp_cats AS c"
		." ON dl.cat_id=c.cat_id"
	." WHERE user_id='$id' $where"
	." ORDER BY dl_status, dl_name ASC");

$last_status = "";
$found = 0;
$more = array();
while($data = dbarray($query_id)) {
	if(!pdpCore::check_access($data['cat_access'])) {
		continue;
	}
	if($last_status != $data['dl_status']) {
		if(!empty($last_status)) {
			echo "</ul>\n";
		}
		$last_status = $data['dl_status'];
		echo "<b>".$locale['PDP904'][$last_status].":</b><ul>\n";
	}

	if(iPDP_MOD || (iMEMBER && $userdata['user_id']==$id)) {
		$more = array();
		if($data['dl_broken_count']>0) {
			$more[] = $locale['PDP163'];
		}
		if($pdp->settings['hide_user_allow']=="yes"
			&& $data['hide_user']=="yes") {
			$more[] = $locale['PDP162'];
		}
	}

	echo "<li>";
	if(($last_status==PDP_PRO_DEL || $last_status==PDP_PRO_CHECK
		|| ($last_status==PDP_PRO_OFF && !$pdp->settings['user_edit']))
		&& !iPDP_MOD) {
		echo $data['dl_name'];
	} elseif($last_status==PDP_PRO_NEW) {
		echo "<a href='edit_desc.php?did=".$data['download_id']."'>"
			.$data['dl_name']."</a>";
	} else {
		echo "<a href='download.php?did=".$data['download_id']."'>"
			.$data['dl_name']."</a>";
	}
	if(count($more)) {
		echo " <span class='small2'>(".implode(", ", $more).")</span>";
	}
	echo "</li>\n";

	$found++;
}
if(dbrows($query_id)) {
	echo "</ul>\n";
}
if($found==0) {
	echo $locale['PDP022'];
}

closetable();

/*
 * subscriptions
 */
if(iMEMBER && $id==$userdata['user_id']) {
	tablebreak();
	opentable($locale['PDP164']);

	if($pdp->settings['allow_notify']=="no") {
		echo "<p><strong>".$locale['PDP057']."</strong>\n";
	}

	$query_id = dbquery("SELECT dl_name, n.download_id, visited"
		." FROM ".DB_PREFIX."pdp_notify AS n"
		." LEFT JOIN ".DB_PREFIX."pdp_downloads AS d"
			." ON n.download_id=d.download_id"
		." WHERE n.user_id='$id'"
		." ORDER BY dl_name ASC");
	if(!dbrows($query_id)) {
		echo "<p><span class='small2'>".$locale['PDP058']."</span>\n";
	} else {
		echo "<ul>\n";
	}
	while($data = dbarray($query_id)) {
		echo "<li><a href='download.php?did=".$data['download_id']."'>"
			.$data['dl_name']."</a>";
		if($data['visited']=="no") {
			echo " (<strong>".$locale['PDP003']."</strong>)";
		}
		echo "</li>\n";
	}
	if(dbrows($query_id)) {
		echo "</ul>\n";
	}

	closetable();
}


require_once(BASEDIR."side_right.php");
require_once(BASEDIR."footer.php");
?>
